/*

Perlin Noise example.

http://freespace.virgin.net/hugo.elias/models/m_perlin.htm

By blending serveral noise matrices together with verying frequencies,
you can get one noise matrix with varying levels of detail.  This example
shows how to make multiple matrices and blend them together into one.

*/
world
	maxx = 30
	maxy = 30
	maxz = 1
	view = 10

turf/proc/SetShade(shade)
	text = "<font bgcolor = [rgb(shade*3,shade*3,shade*3)]> "

mob/verb/PerlinNoise()
	var/Noise/octave_1 = new(30, 30)
	octave_1.frequency = 4
	octave_1.amplitude = 128
	octave_1.smoothness = 2
	octave_1.Randomize()
	var/Noise/octave_2 = new(30, 30)
	octave_2.frequency = 8
	octave_2.amplitude = 64
	octave_2.smoothness = 2
	octave_2.Randomize()
	var/Noise/octave_3 = new(30, 30)
	octave_3.frequency = 16
	octave_3.amplitude = 32
	octave_3.smoothness = 2
	octave_3.Randomize()
	var/Noise/perlin = new(30, 30)
	perlin.Blend(octave_1,octave_2,octave_3)
	usr << "Displaying octave 1:"
	for(var/turf/t in block(locate(1,1,1),locate(30,30,1)))
		t.SetShade(round(octave_1.Noise(t.x,t.y)))
	sleep(60)
	usr << "Displaying octave 2:"
	for(var/turf/t in block(locate(1,1,1),locate(30,30,1)))
		t.SetShade(round(octave_2.Noise(t.x,t.y)))
	sleep(60)
	usr << "Displaying octave 3:"
	for(var/turf/t in block(locate(1,1,1),locate(30,30,1)))
		t.SetShade(round(octave_3.Noise(t.x,t.y)))
	sleep(60)

	usr << "Displaying perlin noise:"
	for(var/turf/t in block(locate(1,1,1),locate(30,30,1)))
		t.SetShade(round(perlin.Noise(t.x,t.y)))