/*
Perhaps the coolest thing you can do with this library is layer noise matices
to generate landscapes.  This demo use one noice matrix to generate elevation,
which is used to to determine if the turf is grass, water, montains, or peaks.
Then, another matrix is used to determine forest density.  If the noise is
above a threshold, it will turn a grass turf into a forest turf.

This demo was intended to look a bit like the rougelike, ADOM.

The demo also shows how the use of seeds can generate maps based on a number.
*/

world
	maxx = 100
	maxy = 100
	maxz = 1
turf
	grass
		text = "<font color = #00FF00>\""
	forest
		text = "<font color = #009000>&"
	water
		text = "<font color = #0000A0>="
	mountains
		text = "<font color = #A0A0A0>^"
	peaks
		text = "<font color = #FFFFFF>^"

world/view = 10
mob/text = "@"
mob/verb/GenerateWorld(seed as num)
	var/Noise/height = new(100, 100)
	height.frequency = 16
	height.amplitude = 100
	height.smoothness = 4
	height.Randomize(seed)
	var/Noise/forest = new(100, 100)
	forest.frequency = 8
	forest.amplitude = 100
	forest.smoothness = 2
	forest.Randomize(seed)
	for(var/turf/t in block(locate(1,1,1),locate(100,100,1)))
		switch(round(height.Noise(t.x,t.y)))
			if(0  to 40)  new /turf/water (t)
			if(41 to 75)  new /turf/grass (t)
			if(76 to 90)  new /turf/mountains (t)
			if(91 to 101) new /turf/peaks (t)
		if(istype(t, /turf/grass))
			if(round(forest.Noise(t.x,t.y))>=75)
				new /turf/forest (t)
